=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2009-02-19 02:16:52 +0000
+++ loggerhead/templates/changelog.pt	2009-02-25 15:29:02 +0000
@@ -104,7 +104,7 @@
                                         <a tal:attributes="title python:'Show revision '+entry.revno;
                                                            href  python:url(['/revision', entry.revno], clear=1);
                                                            class string:link"
-                                           tal:content="entry/comment"></a>
+                                           tal:content="structure python:util.fixed_width(entry.comment)"></a>
                                      </div>
                                 <div class="revisioninfo" style="display:none;">
                                     <ul class="expandrev">

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2009-01-23 19:19:39 +0000
+++ loggerhead/templates/revisioninfo.pt	2009-02-25 15:29:02 +0000
@@ -13,7 +13,7 @@
                tal:content="python:revno_with_nick(merge_point)"></a>
         </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
-        <div class="information" tal:content="python:util.fixed_width(change.comment)"></div>
+        <div class="information" tal:content="structure python:util.fixed_width(change.comment)"></div>
     </div>
     <ul id="list-files">
         <tal:block condition="nocall:modified_file_link">

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2008-10-24 02:26:05 +0000
+++ loggerhead/util.py	2009-02-25 15:29:02 +0000
@@ -24,6 +24,8 @@
 except ImportError:
     from elementtree import ElementTree as ET
 
+from simpletal.simpleTALUtils import HTMLStructureCleaner
+
 import base64
 import cgi
 import datetime
@@ -222,6 +224,7 @@
             s = s.decode('iso-8859-15')
         return s
 
+HSC = HTMLStructureCleaner()
 
 def fixed_width(s):
     """
@@ -238,7 +241,7 @@
             s = s.decode('utf-8')
         except UnicodeDecodeError:
             s = s.decode('iso-8859-15')
-    return s.expandtabs().replace(' ', NONBREAKING_SPACE)
+    return HSC.clean(s).expandtabs().replace(' ', NONBREAKING_SPACE).replace('\n', '<br/>')
 
 
 def fake_permissions(kind, executable):

